
#include <iostream>
#include <fstream>
#include "knowledgebase.h"

using namespace std;
using namespace Prolog;



int main(int argc, char** argv)
{

    /*
    Terms* c1 = new Terms;
    c1->push_back(new CompositeTerm(new string("marge"), NULL));
    c1->push_back(new Variable(new string("H")));
    Term* t1 = new CompositeTerm(new string("husband"), c1);

    Terms* c2 = new Terms;
    c2->push_back(new Variable(new string("W")));
    c2->push_back(new CompositeTerm(new string("homer"), NULL));
    Term* t2 = new CompositeTerm(new string("husband"), c2);

    Unifier* mgu = Unify(t1, t2);
    if(mgu != NULL)
    {
        for(Unifier::iterator i = mgu->begin(); i != mgu->end(); i++)
        {
            i->first->Portray(cout);
            cout << " = ";
            i->second->Portray(cout);
            cout << endl;
        }
        delete mgu;
    }

    delete t1;
    delete t2;
    */


    if(argc > 1)
    {
        ifstream plfile(argv[1]);
        KnowledgeBase* knowledgebase = KnowledgeBase::Parse(plfile);

        if(knowledgebase != NULL)
        {
            // knowledgebase->Portray(cout);

            for(Goals::iterator i = knowledgebase->goals->begin(); i != knowledgebase->goals->end(); i++)
            {
                int GlobalVariables = 1;

                cout << "?- ";
                for(Goal::iterator t = (*i)->begin(); t != (*i)->end(); t++)
                {
                    (*t)->Portray(cout);
                    cout << (t+1 != (*i)->end() ? "," : ".\n");
                }
                cout.flush();

                cout << (Prove(knowledgebase, *i, GlobalVariables) ? "true.\n\n" : "false.\n\n");
            }


            while(true)
            {
                cout << "?- ";

                string input;
                std::getline(cin, input);
                if(cin.eof())
                    break;

                stringstream s;
                s << "?-" << input;
                KnowledgeBase* goal = KnowledgeBase::Parse(s);
                if(goal != NULL)
                {
                    if(goal->goals != NULL)
                        for(Goals::iterator i = goal->goals->begin(); i != goal->goals->end(); i++)
                        {
                            int GlobalVariables = 1;
                            cout << (Prove(knowledgebase, *i, GlobalVariables) ? "true.\n\n" : "false.\n\n");
                        }
                    delete goal;
                }
            }


            delete knowledgebase;
        } // if(knowledgebase != NULL)


        cout << "\n";
    } // if(argc > 1)

    return 0;
}
